// Copyright 2020 Google LLC All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// This code was autogenerated. Do not edit directly.

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"
	"time"

	v1 "agones.dev/agones/pkg/apis/multicluster/v1"
	scheme "agones.dev/agones/pkg/client/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// GameServerAllocationPoliciesGetter has a method to return a GameServerAllocationPolicyInterface.
// A group's client should implement this interface.
type GameServerAllocationPoliciesGetter interface {
	GameServerAllocationPolicies(namespace string) GameServerAllocationPolicyInterface
}

// GameServerAllocationPolicyInterface has methods to work with GameServerAllocationPolicy resources.
type GameServerAllocationPolicyInterface interface {
	Create(ctx context.Context, gameServerAllocationPolicy *v1.GameServerAllocationPolicy, opts metav1.CreateOptions) (*v1.GameServerAllocationPolicy, error)
	Update(ctx context.Context, gameServerAllocationPolicy *v1.GameServerAllocationPolicy, opts metav1.UpdateOptions) (*v1.GameServerAllocationPolicy, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.GameServerAllocationPolicy, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.GameServerAllocationPolicyList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.GameServerAllocationPolicy, err error)
	GameServerAllocationPolicyExpansion
}

// gameServerAllocationPolicies implements GameServerAllocationPolicyInterface
type gameServerAllocationPolicies struct {
	client rest.Interface
	ns     string
}

// newGameServerAllocationPolicies returns a GameServerAllocationPolicies
func newGameServerAllocationPolicies(c *MulticlusterV1Client, namespace string) *gameServerAllocationPolicies {
	return &gameServerAllocationPolicies{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the gameServerAllocationPolicy, and returns the corresponding gameServerAllocationPolicy object, and an error if there is any.
func (c *gameServerAllocationPolicies) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.GameServerAllocationPolicy, err error) {
	result = &v1.GameServerAllocationPolicy{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("gameserverallocationpolicies").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of GameServerAllocationPolicies that match those selectors.
func (c *gameServerAllocationPolicies) List(ctx context.Context, opts metav1.ListOptions) (result *v1.GameServerAllocationPolicyList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.GameServerAllocationPolicyList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("gameserverallocationpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested gameServerAllocationPolicies.
func (c *gameServerAllocationPolicies) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("gameserverallocationpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a gameServerAllocationPolicy and creates it.  Returns the server's representation of the gameServerAllocationPolicy, and an error, if there is any.
func (c *gameServerAllocationPolicies) Create(ctx context.Context, gameServerAllocationPolicy *v1.GameServerAllocationPolicy, opts metav1.CreateOptions) (result *v1.GameServerAllocationPolicy, err error) {
	result = &v1.GameServerAllocationPolicy{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("gameserverallocationpolicies").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(gameServerAllocationPolicy).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a gameServerAllocationPolicy and updates it. Returns the server's representation of the gameServerAllocationPolicy, and an error, if there is any.
func (c *gameServerAllocationPolicies) Update(ctx context.Context, gameServerAllocationPolicy *v1.GameServerAllocationPolicy, opts metav1.UpdateOptions) (result *v1.GameServerAllocationPolicy, err error) {
	result = &v1.GameServerAllocationPolicy{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("gameserverallocationpolicies").
		Name(gameServerAllocationPolicy.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(gameServerAllocationPolicy).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the gameServerAllocationPolicy and deletes it. Returns an error if one occurs.
func (c *gameServerAllocationPolicies) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("gameserverallocationpolicies").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *gameServerAllocationPolicies) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("gameserverallocationpolicies").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched gameServerAllocationPolicy.
func (c *gameServerAllocationPolicies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.GameServerAllocationPolicy, err error) {
	result = &v1.GameServerAllocationPolicy{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("gameserverallocationpolicies").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
