---
title: "1.18.0 - gRPC compatibility fix, RollingUpdateOnReady to stable, SDKGracefulTermination in alpha"
linkTitle: "1.18.0"
date: "2021-10-12"
---

This is the v1.18.0 release of Agones.

This release fixes a gRPC compatibility issue in the allocator service introduced in Agones 1.11.0. If you have a gRPC client that does not work with the allocator server, you can now disable the REST server or set it to a different port for better client compatibility.

The `RollingUpdateOnReady` feature has graduated to stable! And the new alpha feature `SDKGracefulTermination` makes Agones work better with preemptible VMs.

**Note**: Some helm parameters related to the allocator service were renamed to make them more consistent. In particular, if you were setting the `agones.allocator.http.loadBalancerIP` so that helm would automatically set up the server certificate, the parameter has been renamed to `agones.allocator.service.loadBalancerIP`. If you were setting this or any other parameters for the allocator service please check your helm scripts and ensure that you are using the new parameters.

Check the <a href="https://github.com/googleforgames/agones/tree/release-1.18.0" data-proofer-ignore>README</a> for details on features, installation and usage.

**Breaking changes:**

- Allow the ports for gRPC and REST to be configured for the allocator service [\#2272](https://github.com/googleforgames/agones/pull/2272) ([roberthbailey](https://github.com/roberthbailey))
- Changed helm parameters used to configure the allocator service [\#2272](https://github.com/googleforgames/agones/pull/2272) ([roberthbailey](https://github.com/roberthbailey))


**Implemented enhancements:**

- Skip volume mounts in the allocator pod if TLS on mTLS is disabled [\#2276](https://github.com/googleforgames/agones/issues/2276)
- Allow the allocator service to use the go http/2 server [\#2263](https://github.com/googleforgames/agones/issues/2263)
- Move RollingUpdateOnReady to Stable [\#2239](https://github.com/googleforgames/agones/issues/2239)
- Explain how namespace parameter works for allocations [\#2090](https://github.com/googleforgames/agones/issues/2090)
- Proposal: provide allocator-client.default secret in gameserver namespace [\#1686](https://github.com/googleforgames/agones/issues/1686)
- Game Server Allocation advanced filtering: player count, state, reallocation [\#1239](https://github.com/googleforgames/agones/issues/1239)
- Skip the secrets and volume mounts in the allocator pod when they aren't needed [\#2277](https://github.com/googleforgames/agones/pull/2277) ([roberthbailey](https://github.com/roberthbailey))
- Move RollingUpdateOnReady to stable [\#2271](https://github.com/googleforgames/agones/pull/2271) ([Jeffwan](https://github.com/Jeffwan))
- Docs: High Density Integration Pattern [\#2270](https://github.com/googleforgames/agones/pull/2270) ([markmandel](https://github.com/markmandel))
- Docs: Integration Pattern - Reusing GameServers [\#2251](https://github.com/googleforgames/agones/pull/2251) ([markmandel](https://github.com/markmandel))
- Support graceful termination [\#2205](https://github.com/googleforgames/agones/pull/2205) ([bennetty](https://github.com/bennetty))

See <a href="https://github.com/googleforgames/agones/blob/release-1.18.0/CHANGELOG.md" data-proofer-ignore>CHANGELOG</a> for more details on changes.

Images available with this release:

- [gcr.io/agones-images/agones-controller:1.18.0](https://gcr.io/agones-images/agones-controller:1.18.0)
- [gcr.io/agones-images/agones-sdk:1.18.0](https://gcr.io/agones-images/agones-sdk:1.18.0)
- [gcr.io/agones-images/agones-ping:1.18.0](https://gcr.io/agones-images/agones-ping:1.18.0)
- [gcr.io/agones-images/agones-allocator:1.18.0](https://gcr.io/agones-images/agones-allocator:1.18.0)
- [gcr.io/agones-images/autoscaler-webhook:0.3](https://gcr.io/agones-images/autoscaler-webhook:0.3)
- [gcr.io/agones-images/cpp-simple-server:0.13](https://gcr.io/agones-images/cpp-simple-server:0.13)
- [gcr.io/agones-images/crd-client:0.5](https://gcr.io/agones-images/crd-client:0.5)
- [gcr.io/agones-images/nodejs-simple-server:0.5](https://gcr.io/agones-images/nodejs-simple-server:0.5)
- [gcr.io/agones-images/rust-simple-server:0.9](https://gcr.io/agones-images/rust-simple-server:0.9)
- [gcr.io/agones-images/simple-game-server:0.3](https://gcr.io/agones-images/simple-game-server:0.3)
- [gcr.io/agones-images/supertuxkart-example:0.3](https://gcr.io/agones-images/supertuxkart-example:0.3)
- [gcr.io/agones-images/unity-simple-server:0.3](https://gcr.io/agones-images/unity-simple-server:0.3)
- [gcr.io/agones-images/xonotic-example:0.8](https://gcr.io/agones-images/xonotic-example:0.8)

Helm chart available with this release:

- <a href="https://agones.dev/chart/stable/agones-1.18.0.tgz" data-proofer-ignore>
  <code>helm install agones agones/agones --version 1.18.0</code></a>

> Make sure to add our stable helm repository using `helm repo add agones https://agones.dev/chart/stable`

